﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Linq;
using System.Windows;
using Infragistics.Controls.Grids;

namespace XamGridCustomControl.MyImplementation
{
    public class MyXamGrid : XamGrid
    {
        public MyXamGrid()
        {
            ColumnsCollection = new ColumnBaseCollection(Columns.ColumnLayout);
            ColumnsCollection.CollectionChanged += ColumnsCollectionOnCollectionChanged;
        }

        private void ColumnsCollectionOnCollectionChanged(object sender, NotifyCollectionChangedEventArgs notifyCollectionChangedEventArgs)
        {
            var items = (IEnumerable<ColumnBase>)notifyCollectionChangedEventArgs.NewItems;
            Columns.AddRange(items);
        }

        public static readonly DependencyProperty ColumnsCollectionProperty = DependencyProperty.Register(
            "ColumnsCollection", typeof(ColumnBaseCollection), typeof(MyXamGrid), new PropertyMetadata(default(ColumnBaseCollection)));

        public ColumnBaseCollection ColumnsCollection
        {
            get { return (ColumnBaseCollection) GetValue(ColumnsCollectionProperty); }
            set { SetValue(ColumnsCollectionProperty, value); }
        }
    }
}
